//
// Copyright (C) 2004, 2005 Pingtel Corp.
// 
//
// $$
////////////////////////////////////////////////////////////////////////
//////

#ifndef _NetBase64Codec_h_
#define _NetBase64Codec_h_

// SYSTEM INCLUDES
//#include <...>

// APPLICATION INCLUDES
#include <utl/UtlString.h>

// DEFINES
// MACROS
// EXTERNAL FUNCTIONS
// EXTERNAL VARIABLES
// CONSTANTS
// STRUCTS
// TYPEDEFS
// FORWARD DECLARATIONS

//:Class sipx_short_t description which may consist of multiple lines (note the ':')
// Class detailed description which may extend to multiple lines
class NetBase64Codec
{
/* //////////////////////////// PUBLIC //////////////////////////////////// */
public:
    static const char* base64Codes;

/* ============================ CREATORS ================================== */

   virtual
   ~NetBase64Codec();
     //:Destructor

/* ============================ MANIPULATORS ============================== */

   static void encode(sipx_int_t dataSize, const char data[],
                sipx_int_t& encodedDataSize, char encodedData[]);

   static void encode(sipx_int_t dataSize, const char data[], UtlString& encodedData);

        static sipx_int_t encodedSize(sipx_int_t dataSize);

        inline static char decodeChar(const char encoded);

        static void decode(sipx_int_t encodedDataSize, const char encodedData[],
                sipx_int_t& dataSize, char data[]);

        static sipx_int_t decodedSize(sipx_int_t encodedDataSize, const char encodedData[]);

/* ============================ ACCESSORS ================================= */

/* ============================ INQUIRY =================================== */

/* //////////////////////////// PROTECTED ///////////////////////////////// */
protected:
   NetBase64Codec();
     //:Default constructor (disabled)

/* //////////////////////////// PRIVATE /////////////////////////////////// */
private:
   NetBase64Codec(const NetBase64Codec& rNetBase64Codec);
     //:Copy constructor (disabled)

   NetBase64Codec& operator=(const NetBase64Codec& rhs);
     //:Assignment operator (disabled)

};

/* ============================ INLINE METHODS ============================ */

#endif  // _NetBase64Codec_h_
