//
// Copyright (C) 2004, 2005 Pingtel Corp.
// 
//
// $$
////////////////////////////////////////////////////////////////////////
//////

#ifndef _SipUdpServer_h_
#define _SipUdpServer_h_

// SYSTEM INCLUDES
//#include <...>

// APPLICATION INCLUDES
#include <net/SipProtocolServerBase.h>


// DEFINES
// MACROS
// EXTERNAL FUNCTIONS
// EXTERNAL VARIABLES
// CONSTANTS
// STRUCTS
// TYPEDEFS
// FORWARD DECLARATIONS
class SipUserAgent;
class OsStunDatagramSocket ;
class OsNotification ;

//:Class sipx_short_t description which may consist of multiple lines (note the ':')
// Class detailed description which may extend to multiple lines
class SipUdpServer : public SipProtocolServerBase
{
/* //////////////////////////// PUBLIC //////////////////////////////////// */
public:

/* ============================ CREATORS ================================== */

   SipUdpServer(sipx_int_t sipPort = SIP_PORT,
       SipUserAgent* userAgent = NULL,
       const char* natPingUrl = "",
       sipx_int_t natPingFrequency = 0,
       const char* natPingMethod = "PING",
       sipx_int_t udpReadBufferSize = -1,
       UtlBoolean bUseNextAvailablePort = FALSE,
       const char* szBoundIp = NULL);
     //:Default constructor


   virtual
   ~SipUdpServer();
     //:Destructor

/* ============================ MANIPULATORS ============================== */

    sipx_int_t run(void* pArg);

    void shutdownListener();

    void enableStun(const char* szStunServer, 
                    const char* szLocalIp, 
                    sipx_int_t refreshPeriodInSecs, 
                    sipx_int_t stunOptions,
                    OsNotification* pNotification) ;
      //:Enable stun lookups for UDP signaling
      // Use a NULL szStunServer to disable

    UtlBoolean sendTo(const SipMessage& message,
                     const char* address,
                     sipx_int_t port,
                     const char* szLocalSipIp = NULL);

/* ============================ ACCESSORS ================================= */

    void printStatus();

    sipx_int_t getServerPort(const char* szLocalIp = NULL) ;

    UtlBoolean getStunAddress(UtlString* pIpAddress,
                              sipx_int_t* pPort,
                              const char* szLocalIp = NULL) ;

/* ============================ INQUIRY =================================== */


/* //////////////////////////// PROTECTED ///////////////////////////////// */
protected:

    OsSocket* buildClientSocket(sipx_int_t hostPort,
                                const char* hostAddress,
                                const char* localIp);

/* //////////////////////////// PRIVATE /////////////////////////////////// */
private:
    UtlString mNatPingUrl;
    sipx_int_t mNatPingFrequencySeconds;
    UtlString mNatPingMethod;
    UtlString mStunServer ;
    sipx_int_t mStunRefreshSecs ;
    sipx_int_t mStunOptions ;
    OsStatus createServerSocket(const char* localIp,
                                 sipx_int_t& localPort,
                                 const UtlBoolean& bUseNextAvailablePort,
                                 sipx_int_t udpReadBufferSize);

    SipUdpServer(const SipUdpServer& rSipUdpServer);
    //: disable Copy constructor

    SipUdpServer& operator=(const SipUdpServer& rhs);
     //:disable Assignment operator

};

/* ============================ INLINE METHODS ============================ */

#endif  // _SipUdpServer_h_
